Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
go

Select next value for SqlBitsSequence

go


Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
	Start with 0
go

Select next value for SqlBitsSequence

go


Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
	Start with 0
	Increment by 10;
go

Select next value for SqlBitsSequence;
go

Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
	Start with 0
go

drop table t1
go
drop table t2
go

create table t1
(
SeqId integer default (next value for SqlBitsSequence),
ColA  char(1)
)
go
create table t2
(
SeqId integer default (next value for SqlBitsSequence),
ColB  char(1)
)
go
insert into t1(ColA) values('X')
go
insert into t2(ColB) values('Y')
go
go
select * from t1
go
select * from t2
go

drop table t1
go
drop table t2
go

Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
	Start with 0
go
Select top(10) number,
       next value for SqlBitsSequence as SequenceNum
  from master..spt_values 
 where type = 'p';
go
-- Order limitation
Select top(10) number,
       next value for SqlBitsSequence
  from master..spt_values 
 where type = 'p' 
 order by number;

 go
 Select top(10) number,
       next value for SqlBitsSequence over(order by number asc)
  from master..spt_values 
 where type = 'p' 
 order by number;

 go
 --  What about descending ??
 Select top(10) number,
       next value for SqlBitsSequence over(order by number desc)
  from master..spt_values 
 where type = 'p' 
 order by number;
 go
 
 
 go

 Begin Transaction
 Select top(10) number,
       next value for SqlBitsSequence
  from master..spt_values 
 where type = 'p' 
 rollback

 go



Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
	Start with 0
	MAXVALUE 21
	CYCLE
go

 Select top(8) number,
       next value for SqlBitsSequence
  from master..spt_values 
 where type = 'p' 
go




Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
	Start with 0
	MAXVALUE 21
	MINVALUE 0
	CYCLE
go
Select top(8) number,
       next value for SqlBitsSequence
  from master..spt_values 
 where type = 'p' 
go



Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
	Start with 0
	MAXVALUE 21
	MINVALUE 0
	NO CYCLE
go
Select top(8) number,
       next value for SqlBitsSequence
  from master..spt_values 
 where type = 'p' 
go



Drop SEQUENCE SqlBitsSequence
go
CREATE SEQUENCE SqlBitsSequence
    AS int
	Start with 0
go

declare @range_first_value sql_variant
declare @range_last_value sql_variant

EXEC sp_sequence_get_range  @sequence_name = N'SqlBitsSequence', 
                            @range_size = 10,
                            @range_first_value = @range_first_value OUTPUT,
							@range_last_value = @range_last_value OUTPUT 


select cast(@Range_first_value as integer),
	    cast(@Range_last_value as integer)

go
