use AdventureWorks2008R2
go
/* Old 2005 + Way */
/* Filter On row number */
Declare @PageSize integer =20;
Declare @PageOn   integer =3;

with ctePaging
as
(
Select LastName,FirstName,
       row_number() over (order by LastName,BusinessEntityID)-1 
	         as RowN
 from  Person.Person

)
Select * from ctePaging
where RowN between (@PageOn-1)*@PageSize and ((@PageOn)*@PageSize)-1
order by RowN;


go


Select LastName,FirstName,BusinessEntityID
 from  Person.Person
 order by LastName,BusinessEntityID
 offset 20 rows fetch next 20 rows only;

go


Declare @PageSize integer =20;
Declare @PageOn   integer =10;

Select LastName,FirstName,BusinessEntityID
 from  Person.Person
 order by LastName,BusinessEntityID
 offset @PageSize*(@PageOn-1) rows fetch next @PageSize rows only;

go
-- What is happening under the convers ?
Select LastName,FirstName,BusinessEntityID
 from  Person.Person
 order by LastName,BusinessEntityID
 offset 200 rows fetch next 20 rows only;

go

Declare @PageSize integer =20;
Declare @PageOn   integer =10;

with cteKeySeek
as
(
Select 
       LastName,BusinessEntityID
 from  Person.Person
 order by LastName,BusinessEntityID
 offset @PageSize*(@PageOn-1) rows fetch next @PageSize rows only
)
Select cteKeySeek.LastName,
       Person.FirstName,
       cteKeySeek.BusinessEntityID
 from  cteKeySeek
 inner loop join  Person.Person  -- Force Loop Join
   on  cteKeySeek.BusinessEntityID =   Person.BusinessEntityID
order  by cteKeySeek.LastName,cteKeySeek.BusinessEntityID;
